#!/bin/sh
# $Id: run_httperf.sh,v 1.2 2001/12/23 16:01:10 toki Exp $
# -
# wrapper of httperf(1)
#   -> http://www.hpl.hp.com/personal/David_Mosberger/httperf.html

clients=16
server=localhost
port=8088
uri='/index.html'
calls=5
conns=10
other_opts=''

while getopts 'c:s:p:u:n:m:o:h' OPTNAME; do
  case "$OPTNAME" in
  c) clients="$OPTARG";;
  s) server="$OPTARG";;
  p) port="$OPTARG";;
  u) uri="$OPTARG";;
  n) calls="$OPTARG";;
  m) conns="$OPTARG";;
  o) other_opts="$OPTARG";;
  h) cat <<EOF
description: wrapper of httperf(1)
  -> http://www.hpl.hp.com/personal/David_Mosberger/httperf.html
usage: $0 [options]
options:
  -c [clients] (defulat: $clients)
  -s [server] (default: $server)
  -p [port] (default: $port)
  -u [uri] (default: $uri)
  -n [calls] (default: $calls)
  -m [conns] (default: $conns)
  -o [other options] (default: $other_opts)
  -h  show this message.
EOF
     exit 1;;
  *) echo "invalid option!"
     exit 1;;
  esac
done

run() {
  exec httperf \
    --server="$server" \
    --port="$port" \
    --uri="$uri" \
    --num-calls="$calls" \
    --num-conns="$conns" >httperf.log.$1 2>&1
}

cleanup() {
  killall httperf
  exit 1
}

rm -f httperf.log.*
trap cleanup 0 2 15

while :; do
  count="$clients"
  perfs="run 1 &"
  while [ "$count" -gt 1 ]; do
    perfs="$perfs
run $count >&- 2>&- &"
    count=`expr "$count" - 1`
  done

  eval "$perfs"
  wait

  ruby httperflog.rb httperf.log.*
done
