#!/usr/local/bin/ruby
# $Id: token_bench.rb,v 1.1 2001/12/28 13:53:21 toki Exp $
# -
# wwwsrv's token parser accessor benchmark

require 'benchmark'		# -> http://www.notwork.org/~gotoken/ruby/p/benchmark/
require 'wwwsrv/token'

include Benchmark
STDOUT.sync = true

trial = (ARGV.first && ARGV.first.to_i) || 1_000

puts "[WWWsrv::Parser.fetch_token * #{trial}]"
puts(measure{
  trial.times do
    WWWsrv::Parser::fetch_token(' Hello-World')
  end
})

puts "[WWWsrv::parser.fetch_quoted * #{trial}]"
puts "1. simple"
puts(measure{
  trial.times do
    WWWsrv::Parser::fetch_quoted(' "Hello world."')
  end
})
puts "2. quoted pair"
puts(measure{
  trial.times do
    WWWsrv::Parser::fetch_quoted(' "\"Hello world.\""')
  end
})

puts "[WWWsrv::parser.fetch_comment * #{trial}]"
puts "1. simple"
puts(measure{
  trial.times do
    WWWsrv::Parser::fetch_comment(' (Hello world.)')
  end
})
puts "2. nest"
puts(measure{
  trial.times do
    WWWsrv::Parser::fetch_comment(' (Hello (world).)')
  end
})
