#!/usr/local/bin/ruby
# $Id: test.cgi,v 1.2 2001/11/24 02:51:01 toki Exp $

def decodeURL(data)
  data = data.dup
  data.gsub!(/\+/n, ' ')
  data.gsub!(/%([0-9A-Fa-f][0-9A-Fa-f])/n) { |fragment| $1.hex.chr }

  data
end

def quoteHTML(data)
  data = data.dup
  data.gsub!(/&/n, '&amp;')
  data.gsub!(/</n, '&lt;')
  data.gsub!(/>/n, '&gt;')

  data
end

content = <<EOF
<html>
<head>
<title>CGI test of WWWsrv</title>
</head>
<body>
<h1>CGI test of WWWsrv</h1>
EOF

content.concat(<<EOF)
<h2>URL parameters</h2>
<dl>
EOF
if (ENV.include? 'QUERY_STRING') then
  for param in ENV['QUERY_STRING'].split(/&/n, -1)
    param_name, param_value = param.split(/=/n, 2)
    param_name = decodeURL(param_name)
    param_value = param_value ? decodeURL(param_value) : param_name
    content.concat(<<-EOF)
<dt>#{quoteHTML(param_name)}</dt>
<dd>#{quoteHTML(param_value)}</dd>
    EOF
  end
end
content.concat(<<EOF)
</dl>
EOF

if (ENV['REQUEST_METHOD'] == 'POST') then
  content.concat(<<-EOF)
<h2>POST parameters</h2>
<dl>
  EOF
  if (post_data = STDIN.read) then
    for param in post_data.split(/&/n, -1)
      param_name, param_value = param.split(/=/n, 2)
      param_name = decodeURL(param_name)
      param_value = param_value ? decodeURL(param_value) : param_name
      content.concat(<<-EOF)
<dt>#{quoteHTML(param_name)}</dt>
<dd>#{quoteHTML(param_value)}</dd>
  EOF
    end
  end
  content.concat(<<-EOF)
</dl>
  EOF
end

content.concat(<<EOF)
<h2>Environment Variables</h2>
<dl>
EOF
for var_name, var_value in ENV.to_a.sort{ |a, b| a.first <=> b.first }
  content.concat(<<-EOF)
<dt>#{quoteHTML(var_name)}</dt>
<dd>#{quoteHTML(var_value)}</dd>
EOF
end
content.concat(<<EOF)
</dl>
EOF

STDOUT.binmode
print "Status: 200 OK\r\n"
print "Content-Type: text/html\r\n"
print "Content-Length: #{content.length}\r\n"
print "\r\n"
print content
