#!/usr/local/bin/ruby
# $Id: test_version.rb,v 1.2 2002/01/01 13:21:13 toki Exp $
# -
# Test of WWWsrv::HTTPversion class

require 'wwwsrv/version'
require 'runit/testcase'
require 'runit/cui/testrunner'

module TestWWWsrv
  class TestHTTPversion < RUNIT::TestCase
    def setup
      @http_0_9 = WWWsrv::HTTPversion::new(0, 9)
      @http_1_0 = WWWsrv::HTTPversion::new(1, 0)
      @http_1_1 = WWWsrv::HTTPversion::new(1, 1)
    end

    def test_new
      assert_instance_of(WWWsrv::HTTPversion, @http_0_9)
      assert_instance_of(WWWsrv::HTTPversion, @http_1_0)
      assert_instance_of(WWWsrv::HTTPversion, @http_1_1)
    end

    def test_major
      assert_equal(0, @http_0_9.major)
      assert_equal(1, @http_1_0.major)
      assert_equal(1, @http_1_1.major)
    end

    def test_minor
      assert_equal(9, @http_0_9.minor)
      assert_equal(0, @http_1_0.minor)
      assert_equal(1, @http_1_1.minor)
    end

    def test_compare
      assert(@http_0_9 < @http_1_0)
      assert(@http_1_0 > @http_0_9)
      assert(@http_1_0 < @http_1_1)
      assert(@http_1_1 > @http_1_0)
      assert(@http_0_9 < @http_1_1)
      assert(@http_1_1 > @http_0_9)
      http_1_0 = WWWsrv::HTTPversion::new(1, 0)
      assert(@http_1_0 == http_1_0)
    end

    def test_to_s
      assert_equal("HTTP/0.9", @http_0_9.to_s)
      assert_equal("HTTP/1.0", @http_1_0.to_s)
      assert_equal("HTTP/1.1", @http_1_1.to_s)
    end
  end
end

if ($0 == __FILE__) then
  TestWWWsrv::constants.map{ |name|
    TestWWWsrv::const_get(name)
  }.select{ |const|
    (const.kind_of? Class) && (const < RUNIT::TestCase)
  }.each do |test_case|
    RUNIT::CUI::TestRunner::run(test_case::suite)
  end
end
