# $Id: echo.rb,v 1.1.2.1 2002/01/14 13:13:16 toki Exp $
# -
# echo of HTTP request

=begin
Copyright (c) 2001-2002
	TOKI Yoshinori <toki@freedom.ne.jp>. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  1.  Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.

  2.  Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.

  3.  The name of the author may not be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
=end

require 'wwwsrv/const'
require 'wwwsrv/document'

module WWWsrv
  class Echo < Document
    def content(sid, srv_opt, prefix, request, response)
      srv_opt.log.debug("sid #{sid}: debug #{type}")
      response.header.content_type = 'text/html'
      yield(response)
      yield(<<-EOF)
<html>
<head>
<title>Request Echo</title>
</head>
<h1>Request Echo</h1>
<h2>Request Line</h2>
<dl>
<dt>Method</dt>
<dd>#{quoteHTML(request.method)}</dd>
<dt>Path</dt>
<dd>#{quoteHTML(request.path)}</dd>
<dt>Version</dt>
<dd>#{quoteHTML(request.version.to_s)}</dd>
</dl>
<h2>Request Header</h2>
<dl>
#{request.header.map{ |field_name, field_value|
    '<dt>' + quoteHTML(field_name) + "</dt>\n" +
    '<dd>' + quoteHTML(field_value) + '</dd>'
  }.join("\n")}
</dl>
</html>
      EOF
    end
  end
end
