# $Id: parser.rb,v 1.3.2.1 2002/01/14 13:13:22 toki Exp $
# -
# HTTP Parser

=begin
Copyright (c) 2001-2002
	TOKI Yoshinori <toki@freedom.ne.jp>. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  1.  Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.

  2.  Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.

  3.  The name of the author may not be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
=end

require 'wwwsrv/const'
require 'wwwsrv/token'
require 'wwwsrv/header'
require 'wwwsrv/multipart'
require 'wwwsrv/form'
require 'wwwsrv/chunk'
require 'wwwsrv/version'
require 'wwwsrv/request'
require 'wwwsrv/response'

module WWWsrv
  # for backward compatibility
  module Parser
    include Token
    module_function :fetch_token
    module_function :fetch_quoted
    module_function :fetch_comment
    module_function :quote_token

    include ChunkedTransferCoding
    module_function :parse_chunk
    module_function :each_chunk

    def parse_header(input, *args)
      Header::parse(input, *args)
    end
    module_function :parse_header

    include Multipart
    module_function :each_multipart
    module_function :parse_multipart

    include FormData
    module_function :parse_query
    module_function :parse_form_data

    include ChunkedTransferCoding
    module_function :parse_chunk
    module_function :each_chunk

    def parse_http_version(description)
      HTTPversion::parse(description)
    end
    module_function :parse_http_version

    def parse_request_line(input)
      Request::parse_line(input)
    end
    module_function :parse_request_line

    def parse_request(input)
      Request::parse(input)
    end
    module_function :parse_request

    def parse_status_line(input)
      Response::parse_status_line(input)
    end
    module_function :parse_status_line

    def parse_status_header(field_value)
      Response::parse_status(field_value)
    end
    module_function :parse_status_header
  end
end
