# $Id: srvopt.rb,v 1.4.2.1 2002/01/14 13:13:25 toki Exp $
# -
# server option

=begin
Copyright (c) 2001-2002
	TOKI Yoshinori <toki@freedom.ne.jp>. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  1.  Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.

  2.  Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.

  3.  The name of the author may not be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
=end

require 'wwwsrv/const'

module WWWsrv
  module Accessor
    def method_missing(id, *args)
      case (args.length)
      when 0
	self[id]
      when 1
	self[id.id2name.sub(/=$/n, '').intern] = args.shift
      else
	raise 'wrong arguments: ' + args.map{ |arg| arg.inspect }.join(', ')
      end
    end

    def self::wrap(obj)
      obj.extend(self)
    end
  end

  class ServerOption
    include Accessor
    include Enumerable

    def initialize(root=nil, log=nil, scheme='http')
      @parser = Parser		# for backward compatibility
      @root = root
      @log = log
      @scheme = scheme
      @option = {}
    end

    attr_accessor :parser	# for backward compatibility
    attr_accessor :root
    attr_accessor :log
    attr_accessor :scheme

    def [](key)
      @option[key]
    end

    def []=(key, value)
      @option[key] = value
    end

    def delete(key)
      @option.delete(key)
    end

    def each
      for key, value in @option
	yield(key, value)
      end
    end
  end
end
